/*-------------------------------------------------------------------

AOCE Post Office Protocol (POP) / Simple Mail Transfer Protocol (SMTP)
Mail Service Access Module

written by Steve Falkenburg-- MacDTS
1991-1993 Apple Computer, Inc.

--------------
change history
--------------

SJF		02/19/93	update for beta build	b1
SJF		10/29/92	update to a11			a11
SJF		06/08/92	update to a8			a8
SJF		02/15/92	first working version	a4.5
SJF		10/16/91	initial coding			a3

---------------------------------------------------------------------*/

#ifndef __TYPES__
#include <Types.h>
#endif

#ifndef __TRAPS__
#include <Traps.h>
#endif

#ifndef __OSUTILS__
#include <OSUtils.h>
#endif

#ifndef __GESTALTEQU__
#include <GestaltEqu.h>
#endif

#include "trapavailable.h"

short NumToolboxTraps(void);
TrapType GetTrapType(short theTrap);
	
short NumToolboxTraps(void)
{
	if (NGetTrapAddress(_InitGraf, ToolTrap) == NGetTrapAddress(0xAA6E,ToolTrap))
		return 0x0200;
	else
		return 0x0400;
}

TrapType GetTrapType(short theTrap)
{
	if ((theTrap & 0x0800) > 0)
		return ToolTrap;
	else
		return OSTrap;
}

Boolean	TrapAvailable(short theTrap)
{
	TrapType tType;
	Boolean isAvail;
	
	tType = GetTrapType(theTrap);
	if (tType == ToolTrap)
		{
			theTrap &= 0x07FF;
			if (theTrap >= NumToolboxTraps())
				theTrap = _Unimplemented;
		}
	
	isAvail = NGetTrapAddress(theTrap, tType) != NGetTrapAddress(_Unimplemented, ToolTrap);
	return isAvail;
}